/*****************************************************************************
* | File        :   MotorDriver.c
* | Author      :   Waveshare team
* | Function    :   
* | Info        :
* 
*----------------
* |	This version:   V1.0
* | Date        :   2018-10-13
* | Info        :   Basic version
*
******************************************************************************/
#include "MotorDriver.h"
#include "Debug.h"  //DEBUG()
MOTOR Motor;

/**
 * Select motor
 *
 * @param name: motor.
 *
 * Example:
 * Motor_Init();
 * 
 */
void Motor_Init(void)
{
  // PU- DR- MF- to GND
  Motor.Positive = 1;
  Motor.Negative = 0;
}

/**
 * The motor stops rotating and the driver chip is disabled.
 *
 */
void Motor_Stop(void)
{
    DEV_Digital_Write(ENABLE_PIN, Motor.Positive);
}

/**
 * turn.
 *
 * @param dir: direction.
 * @param steps: Step count.
 * @param stepdelay: step delay.
 *
 * Example:
 * Motor_TurnStep()
 */
void Motor_TurnStep(UBYTE dir, UWORD steps, UWORD stepdelay)
{
    if(dir == FORWARD) {
        DEV_Digital_Write(ENABLE_PIN, Motor.Negative);
        DEV_Digital_Write(DIR_PIN, Motor.Negative);
    } else if(dir == BACKWARD) {
        DEV_Digital_Write(ENABLE_PIN, Motor.Negative);
        DEV_Digital_Write(DIR_PIN, Motor.Positive);
    }    else {
        DEV_Digital_Write(ENABLE_PIN, Motor.Positive);
    }

    if(steps == 0)
        return;

    UWORD i = 0;
    DEBUG("turn %d steps\r\n", steps);
    for(i = 0; i < steps; i++) {
        DEV_Digital_Write(STEP_PIN, 1);
        DEV_Delay_ms(stepdelay);
        DEV_Digital_Write(STEP_PIN, 0);
        DEV_Delay_ms(stepdelay);
    }

}
